unit olympia_weighted1;

{$mode objfpc}{$H+}

interface

uses
   Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, Grids,
	 ExtCtrls, Types;

type

	 { TForm1 }

   TForm1 = class(TForm)
			Button10: TButton;
			Button11: TButton;
			Button6: TButton;
			Button9: TButton;
			ComboBox1: TComboBox;
			GroupBox1: TGroupBox;
			Memo1: TMemo;
			RadioGroup1: TRadioGroup;
			StringGrid1: TStringGrid;
			procedure ComboBox1Select(Sender: TObject);
			procedure FormActivate(Sender: TObject);
      procedure InitCombo;
			procedure Button10Click(Sender: TObject);
			procedure Button11Click(Sender: TObject);
      procedure GetMedals (ro: Integer;var med1,med2,med3:integer);
			procedure StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
				 aRect: TRect; aState: TGridDrawState);
			procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
				 aState: TGridDrawState);
      procedure WeigtenMedals;
      procedure NumWeighten;
      procedure niceNum;
      procedure SortMedals;
		  procedure Button6Click(Sender: TObject);
		  procedure Button9Click(Sender: TObject);
	    procedure FormCreate(Sender: TObject);
   private

   public

   end;

var
   Form1: TForm1;

implementation

{$R *.lfm}


const LE = LineEnding;

{ TForm1 }



procedure TForm1.InitCombo;
var i : integer;
begin
for i := 1 to StringGrid1.RowCount-1 do
     ComboBox1.Items.add(StringGrid1.cells[2,i]);
   ComboBox1.Sorted:= true;
end;

procedure TForm1.ComboBox1Select(Sender: TObject);
var Country : string;
    i : integer;
begin
   //showMessage (ComboBox1.items[ComboBox1.ItemIndex]);
   country := ComboBox1.items[ComboBox1.ItemIndex];
   for i := 1 to StringGrid1.RowCount-1 do
      begin
      if StringGrid1.cells[2,i] = country then
         begin
          StringGrid1.Row:=i;
          StringGrid1.Col:=2;
          StringGrid1.SetFocus;
          break;
				 end;
			end;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
    If Screen.Height <= 1024 then self.Top := 0;
    OnActivate:= Nil;

end;


// insert space at every 'block' - 2 for hex, 3 for decimals
function goodLooking (s: string; blocklen: integer) : string;
var i,k : integer;
     begin
       result := ''; k := 1;
       for i := length(s) downto 1 do
       begin
	        result := s[i]+result;
	        if (k mod Blocklen = 0) and (i>1) then result := #32+ result;
	        inc (k);
		   end;
		end;


procedure TForm1.niceNum;
var i,k : integer;
    s: string;
begin
for i := 1 to StringGrid1.RowCount-1 do
  begin
  s:= StringGrid1.cells[6,i];
  s := goodLooking(s,3);
  StringGrid1.cells[6,i] := s;
	end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var i : integer;
    s : string;
begin
   StringGrid1.LoadFromCSVFile('./medals_ISO.txt','|',true);
   StringGrid1.SelectedColor:=clRed;
   StringGrid1.Options := StringGrid1.Options + [goDrawFocusSelected];
   InitCombo;
   s := StringGrid1.cells[6,1]; // population
   if pos (' ',s) = 0 then niceNum;
   for i := 0 to StringGrid1.ColCount-1 do
              StringGrid1.AutoSizeColumn(i);
   SortMedals;


end;




procedure TForm1.Button6Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.NumWeighten;
var i, ShowI : integer;
    i1,i2,i3,k1,k2,k3 : integer;
begin
ShowI := 1;
stringGrid1.Cells[10,1] := '1';
for i := 2 to StringGrid1.rowCount - 1 do
  begin
   GetMedals (i-1,i1,i2,i3);
	 GetMedals (i,k1,k2,k3);
   if (i1 = k1) and (i2=k2) and (i3=k3) then
      else showI := i;
   //showMessage (IntToStr(i)+' / '+IntToStr(showI));
   stringGrid1.Cells[10,i] := IntToStr(showI);
	end;
StringGrid1.SaveToCSVFile('./medals_ISO.txt','|',true);
end;

procedure TForm1.WeigtenMedals;
var i,m1,m2,m3,w1,w2,w3,po : integer;
tmp : string;
begin
// 3 8
with StringGrid1 do
begin
for i := 1 to RowCount - 1 do
    begin
    m1 := StrToInt (cells[3,i]);
    m2 := StrToInt(cells[4,i]);
    m3 := StrToInt(Cells[5,i]);
    tmp := cells[6,i];
    tmp := StringReplace(tmp,' ','',[rfReplaceAll]);
    po := StrToInt(tmp);
    w1 := round (100000000/po*m1);
    w2 := round (100000000/po*m2);
    w3 := round (100000000/po*m3);
    cells[7,i] := IntToStr(w1);
    cells[8,i] := IntToStr(w2);
    cells[9,i] := IntToStr(w3);

		end; // i
end; // with
if RadioGroup1.ItemIndex = 1 then NumWeighten;
end;


procedure TForm1.GetMedals (ro: Integer;var med1,med2,med3:integer);
   var s1,s2,s3 : string;
   begin
   with StringGrid1 do
   begin
	 if RadioGroup1.ItemIndex = 0 then //official
	      begin
	      s1 :=  (cells[3,ro]);
	      s2 := (cells[4,ro]);
	      s3 := (Cells[5,ro]);
			  end else  // weighted
	      begin
	      s1 :=  (cells[7,ro]);
	      s2 := (cells[8,ro]);
	      s3 := (Cells[9,ro]);
	      end;
    end; // with
    med1 := StrToInt(s1);
    med2 := StrToInt(s2);
    med3 := StrToInt(s3);
	 end;

procedure TForm1.StringGrid1DrawCell(Sender: TObject; aCol, aRow: Integer;
	 aRect: TRect; aState: TGridDrawState);
   var fname : string;
       png : TPortableNetworkGraphic;
       x : integer;
begin
   if (arow >0) and (acol = 11) then
     begin
     fname := StringGrid1.Cells[1,arow];
     fname := './flags/smallwave'+fname +'.png';
     if FileExists(fname) then
        begin
        png := TPortableNetworkGraphic.create;
        png.LoadFromFile(fname);
        if odd (aRow) then x := 25 else x := 0;
        StringGrid1.Canvas.Draw(aRect.Left+x,aRect.Top,png);
        png.free;
				end;
		 end;
end;

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
	 aState: TGridDrawState);
var
  MyTextStyle: TTextStyle;
begin
  if (aCol=6) then
  begin
    MyTextStyle := StringGrid1.Canvas.TextStyle;
    MyTextStyle.Alignment := taRightJustify;
    StringGrid1.Canvas.TextStyle := MyTextStyle;
  end;
  if (aCol in [0,3,4,5,7,8,9,10]) then
  begin
    MyTextStyle := StringGrid1.Canvas.TextStyle;
    MyTextStyle.Alignment := taCenter;
    StringGrid1.Canvas.TextStyle := MyTextStyle;
  end;

end;



procedure TForm1.SortMedals; // slow, slow but we have quick PCs....
var i,k, i1,i2,i3,k1,k2,k3 : Integer;
    sortIt : boolean;
begin
for i := 1 to StringGrid1.RowCount -2  do
   begin
   GetMedals(i,i1,i2,i3);
   for k := i+1 to StringGrid1.RowCount -1  do
     begin
     getMedals(k,k1,k2,k3);
     Sortit :=  k1 > i1;
     if not sortIt then
        begin
        SortIt := (i1=k1) and (k2 > i2);
        If not sortit then sortit := (i1=k1) and (i2=k2) and (k3>i3);
        if not  sortit then sortit := (i1=k1) and (i2=k2) and (i3=k3) and
           (StringGrid1.cells[2,k] < StringGrid1.Cells[2,i]); // county alphabet
        end;
        if sortIt then
           begin
           StringGrid1.ExchangeColRow(false,i,k);
           GetMedals(i,i1,i2,i3);
					 end;
		 end; // k
	 end; //k

end;

procedure TForm1.Button10Click(Sender: TObject);
begin
   SortMedals;
   With StringGrid1 do
     begin
     row := 1;
     col := 2;
     setfocus;
		 end;// with
end;

procedure TForm1.Button11Click(Sender: TObject);
 var st,straw,stTemp :tStringList;
    s : string;
    i,k : Integer;
    sa: TStringArray;
    rank,country,m1,m2,m3,c:  string;
    found : boolean;
begin
    Straw := TStringList.create;
    st := TStringlist.create;
    straw.LoadFromFile('./medals_update.txt');
    i:= 0;
    while i < straw.Count do
      begin
      s := straw[i]+straw[i+1]+straw[i+2];
      s:=StringReplace(s,#9,'|',[rfReplaceAll]);
      st.add(s);
      inc(i,3);
			end;
    showMessage (st.text);
    straw.free;
    for i := 0 to st.count - 1 do
       begin
       sa := st[i].Split('|');
       for k := 0 to high(sa) do sa[k] := trim(sa[k]);
       rank := sa[0];
       country := sa[1];
       m1 := sa[2]; M2 := sa[3]; m3 := sa[4];
       found := false;
       for k := 1 to StringGrid1.RowCount - 1 do
         begin
         c := StringGrid1.cells[2,k];
         if c = country then
            begin
            found := true;
            if StringGrid1.cells[3,k] <> m1 then
               begin
               showMessage (Country+' M1 changed');
               StringGrid1.cells[3,k]  := m1;
							 end;
            if StringGrid1.cells[4,k] <> m2 then
               begin
               showMessage (Country+' M2 changed');
               StringGrid1.cells[4,k]  := m2;
							 end;
            if StringGrid1.cells[5,k] <> m3 then
               begin
               showMessage (Country+' M3 changed');
               StringGrid1.cells[5,k]  := m3;
							 end;
            if StringGrid1.cells[0,k] <> rank then
                begin
                showMessage (country+' rank changed '+rank);
                StringGrid1.cells[0,k]  := rank;

								end;
						 break;
						end; //if
				 end;  // k
         if not found then showMessage (country+' not found');
			 end; // i

     RadioGroup1.ItemIndex := 1;
     WeigtenMedals;
     NumWeighten;
     SortMedals;
     StringGrid1.saveToCSVFile('./medals_ISO.txt','|',true);
     st.free;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
   WeigtenMedals;
end;



end.

